#
# $Id: exec_rss_out.rb,v 1.3 2005/08/25 19:07:56 Yuukis Exp $
#
# RSS 1.0/2.0 output plug-in for RTDS.
#

SITE_TITLE = 'No Title Diary'
SITE_AUTHOR = 'Anonymous Coward'
SITE_DESCRIPTION = 'No description'
SITE_URI = 'http://example.com/'
RSS10_FN = 'index.rdf'
RSS20_FN = 'index.xml'
RSS10_URI = SITE_URI + RSS10_FN
RSS20_URI = SITE_URI + RSS20_FN

def exec_rss_out
	rss = RSS.new
	rss.write(Uconv.euctou8(rss.out('1.0')), BASE_DIRECTORY + RSS10_FN)
	rss.write(Uconv.euctou8(rss.out('2.0')), BASE_DIRECTORY + RSS20_FN)
end

class RSS
	def initialize
		@last = File.mtime(INDEX_FILE)
		@rss = []
		idx = IO.readlines(INDEX_FILE).join

		idx.gsub(/<h3 class="article_title"><a.*?href="(.*?)">.*?<\/a> (.*)<\/h3>/) {
			@rss << {'link' => SITE_URI + $1}
			@rss.last['title'] = $2.gsub(/<.*?>/, '')
		}

		i = 0
		idx.gsub(/<div class="article_body">(.*?)<\/div>/m) {
			contents = $1
			descript = contents.gsub(/<.*?>/, '').gsub(/\n/, '')
			descript.sub(/(.{1,100})(.*)/e) {
				@rss[i]['description'] = $1
				@rss[i]['description'] += '...' if $2 != ''
			}
			@rss[i]['content'] = contents
			i += 1
		}
	end

	def out(version = '1.0')
		if version == '1.0'
			ERB.new(IO.readlines(PLUGIN_FILES + 'rss10.erb').join, nil, '%').result(binding)
		elsif version == '2.0'
			ERB.new(IO.readlines(PLUGIN_FILES + 'rss20.erb').join, nil, '%').result(binding)
		end
	end

	def write(str, file_name)
		fh = File.open(file_name, 'w')
		fh.write str
		fh.close
	end
end
