#
# $Id: rtds_calender.rb,v 1.9 2005/08/26 17:41:53 Yuukis Exp $
#
# Original Code is.......
# Created: March 26,1999 Friday 14:55:05
# Author: tetsu(WATANABE Tetsuya)
#
# I've known calendar is calend*a*r, but too late. by Ys.

class TCalendar
  def initialize(y,m)
    @holiday = []
    @mday_arr = []
    1.upto(31) do |d|
      @mday_arr[d] = Time.local(y.to_i, m.to_i, d, 0, 0, 0)
      if d > 28
        if @mday_arr[d].month != m.to_i
          @mday_arr[d] = nil
        end
      end
    end
    @month_name = @mday_arr[1].strftime('%B')
  end

  def nMonday(n)
    count = 0
    @mday_arr.each_index do |d|
      next if d < 1
      count += 1 if @mday_arr[d].wday == 1
      return d if count == n
    end
  end

  def wday(mday)
    return nil unless @mday_arr[mday]
    @mday_arr[mday].wday
  end

  def status(mday)
    return nil unless @mday_arr[mday]
    case @mday_arr[mday].wday
    when 1, 2, 3, 4, 5
      'workday'
    when 0
      'holiday'
	when 6
	  'weekend'
    end
  end

  def header
    msg = "<table class=\"calender\">\n" ##{@mday_arr[1].strftime('%B %Y')}
    msg + "<tr><th>Sun</th><th>Mon</th><th>Tue</th><th>Wed</th><th>Thu</th><th>Fri</th><th>Sat</th></tr>\n"
  end
end

def cal_add_tag(status,d)
	case status
	when 'holiday'
		%Q(<td class="holiday">#{d}</td>)
	when 'weekend'
		%Q(<td class="weekend">#{d}</td>)
	when 'workday'
		%Q(<td>#{d}</td>)
	when 'other'
		%Q(<td class="other_file">#{d}</td>)
	end
end


def main
	cal = TCalendar.new(@year,@month)
	msg = cal.header

	1.upto(31) do |d|
	  wday = cal.wday(d)
	  break unless wday

	  status = cal.status(d)

	  if (d == 1)
	    msg.concat('<td></td>' * wday)
	  elsif wday == 0
	    msg.concat("</tr>\n")
	  end

	  day_str =
		case @day_suffix
			when "a"
				if d < 16
					cal_add_tag(status,d)
				else
					cal_add_tag('other',d)
				end
			when "b"
				if d > 15
					cal_add_tag(status,d)
				else
					cal_add_tag('other',d)
				end
		end

	    msg.concat(day_str)
	end
	return(msg)
end


def rtds_calender
	fn = "#{PLUGIN_FILES}/#{@year}#{@month}#{@day_suffix}.calender"
	d = @day.to_i.to_s

	if File.exist?(fn)
		msg = IO.readlines(fn).join
		msg.sub!(">#{d}<","><a href=\"#d#{@year}#{@month}#{@day}\">#{d}</a><")
	else
		msg = main.gsub(/^<td/,"<tr><td")
		msg.sub!(">#{d}<","><a href=\"#d#{@year}#{@month}#{@day}\">#{d}</a><")
		msg << "</tr>\n</table>\n"
	end

	fh = File.open(fn, 'w')
	fh.write msg
	fh.close

	msg
end
